import { BasicNeatType, PathElements } from '../../types/neat';
import { Bool, Float32, Float64, Int, Pointer, Str } from './NeatTypes';
interface SerializedNeatType {
    __neatTypeClass: string;
    value: unknown;
}
interface PointerNeatType {
    type: Pointer['type'];
    value: PathElements;
    delimiter: string;
}
export declare function isFloat32(value: BasicNeatType): value is Float32;
export declare function isFloat64(value: BasicNeatType): value is Float64;
export declare function isInt(value: BasicNeatType): value is Int;
export declare function isStr(value: BasicNeatType): value is Str;
export declare function isBool(value: BasicNeatType): value is Bool;
export declare function isBasicNeatType(value: unknown): value is BasicNeatType;
export declare function isNeatType(value: unknown): boolean;
export declare function sortMapByKey(a: [Uint8Array, unknown], b: [Uint8Array, unknown]): number;
export declare class NeatTypeSerializer {
    private static NEAT_TYPE_MAP;
    static serialize(neatTypeInstance: BasicNeatType | PointerNeatType): SerializedNeatType;
    static deserialize(serializedNeatType: SerializedNeatType): BasicNeatType | PointerNeatType;
}
export {};
